/**
 * 剧情
 */

import { systemConfig } from "../config/serverConfig";
import { juqingTableData, NPCTableData } from "../data/table/tableData";
import { changeJsonData, getJsonData } from "../util/tools";

/**
 * 剧情
 * @param type 游戏板块
 * @param playId 剧情id
 * @param dhId 对话id(后置剧情id)
 * @returns 
 */
export function getPlayData(type:string, playId:string, dhId:string) {
    let excelData = juqingTableData(type, playId);

    let playData = excelData[playId].dataList;
    // let duihua = 1;
    let nextStory:any = {};
    playData.forEach( info => {
        let {dhid, dh, jqlx, hzjqid, glnpc, glxsid} = info;

        if (dhid == dhId) {
            //根据传入的id查找对应对话
            nextStory = info;
            nextStory["img"] = `${systemConfig.ipUrl}NPC/${glnpc}.png`;

            //记录当前走到的剧情
            plotClues(type, playId, dhId, glxsid);
        }
    });

    if (nextStory) {
        let dhStory = [];
        if(nextStory.jqlx == "选择") {
            nextStory.hzjqid = JSON.parse(nextStory.hzjqid);
            for (let i = 0; i < nextStory.hzjqid.length; i++ ) {
                let dhData = playData.find(s => s.dhid == nextStory.hzjqid[i]);
                if(dhData) dhStory.push(dhData);
            }
            nextStory.hzjq = dhStory;
            nextStory.img = `${systemConfig.ipUrl}NPC/${nextStory.glnpc}.png`
        }
    }

    return nextStory;
}


/**
 * 获取对应游戏板块的NPC
 * @param type 
 * @returns 
 */
export function getNPCData(type) {
    let excelData = NPCTableData();
    let npcData = excelData['NPC'].dataList;

    let npcByType = [];
    npcData.forEach( info => {
        let {mc, lx, dyjqid} = info;
        if(lx == type) {
            npcByType.push({name:mc, type:lx, img:`${systemConfig.ipUrl}NPC/${mc}.png`, jqid:dyjqid})
        }
    })

    return npcByType;
}



/**
 * 剧情相关线索
 */
export function plotClues(type:string, playId:string, dhId:string, glxsid:string) {
    //获取已有json数据
    let baseData = getJsonData("json/基础数据.json");

    let userData = {};
    if(Object.keys(baseData).length === 0) { //没有对应数据的情况
        userData["初始资金"] = 500;
        userData[type] = {};
        if (Object.keys(userData[type]).length === 0) {
            userData[type][playId] = {"当前对话id": dhId, "已获得的线索":[]};
            
            if (glxsid) {
                let fruitsEmpty;
                if(glxsid.includes('，')) fruitsEmpty = glxsid.split("，");
                else fruitsEmpty = [glxsid];

                if(!userData[type][playId]["已获得的线索"]) userData[type][playId]["已获得的线索"] = fruitsEmpty
                else {
                    for(let i = 0; i < fruitsEmpty.length; i++) {
                        userData[type][playId]["已获得的线索"].push(fruitsEmpty[i]);
                        let uniqueArray = [...new Set(userData[type][playId]["已获得的线索"])];
                        userData[type][playId]["已获得的线索"] = uniqueArray;
                    }
                }
            }
        }
    } else { //已经有对应数据
        userData = baseData["1727399696222"];
        // userData["结算"] = baseData["1727399696222"]["结算"] + 50; //暂时一个剧情对话回合加50银两
        if (!userData[type]) {
            userData[type] = {};
            if(!userData[type][playId]) userData[type][playId] = {"当前对话id":"", "已获得的线索":[]};
            userData[type][playId]["当前对话id"] = dhId;
            userData[type][playId]["已获得的线索"] = [];
            
            if (glxsid) {
                let fruitsEmpty;
                if(glxsid.includes('，')) fruitsEmpty = glxsid.split("，");
                else fruitsEmpty = [glxsid];

                if(!userData[type][playId]["已获得的线索"]) userData[type][playId]["已获得的线索"] = fruitsEmpty
                else {
                    for(let i = 0; i < fruitsEmpty.length; i++) {
                        userData[type][playId]["已获得的线索"].push(fruitsEmpty[i]);
                        let uniqueArray = [...new Set(userData[type][playId]["已获得的线索"])];
                        userData[type][playId]["已获得的线索"] = uniqueArray;
                    }
                }
            }
        } else {
            if (userData[type][playId]) {
                if (userData[type][playId]["当前对话id"] == dhId) return;
                else userData[type][playId]["当前对话id"] = dhId;
            } else userData[type][playId] = {"当前对话id":dhId};
            // userData[type][playId]["当前对话id"] = dhId;
            if (glxsid) {
                let fruitsEmpty;
                if(glxsid.includes('，')) fruitsEmpty = glxsid.split("，");
                else fruitsEmpty = [glxsid];

                if(!userData[type][playId]["已获得的线索"]) userData[type][playId]["已获得的线索"] = fruitsEmpty
                else {
                    for(let i = 0; i < fruitsEmpty.length; i++) {
                        userData[type][playId]["已获得的线索"].push(fruitsEmpty[i]);
                        let uniqueArray = [...new Set(userData[type][playId]["已获得的线索"])];
                        userData[type][playId]["已获得的线索"] = uniqueArray;
                    }
                }
            }
        }
    }

    //暂定一个默认用户1727399696222
    let changeData = {"1727399696222":userData};
    //更新json数据
    changeJsonData("json/基础数据.json", changeData);

    console.log("基础数据更新成功");
}



function a(type:string, playId:string, dhId:string, glxsid:string) {
    //获取已有json数据
    let baseData = getJsonData("json/基础数据.json");

    let userData = {};
    if(Object.keys(baseData).length === 0) { //没有对应数据的情况
        userData["初始资金"] = 500;
        userData[type] = {};
        if (Object.keys(userData[type]).length === 0) {
            userData[type][playId] = {"当前对话id": dhId, "已获得的线索":[]};
            
            if (glxsid) {
                let fruitsEmpty;
                if(glxsid.includes('，')) fruitsEmpty = glxsid.split("，");
                else fruitsEmpty = [glxsid];

                if(!userData[type][playId]["已获得的线索"]) userData[type][playId]["已获得的线索"] = fruitsEmpty
                else {
                    for(let i = 0; i < fruitsEmpty.length; i++) {
                         userData[type][playId]["已获得的线索"].push(fruitsEmpty[i]);
                    }
                }
            }
        }
    } else { //已经有对应数据
        userData = baseData["1727399696222"];
        if (!userData[type]) {
            userData[type] = {};
            if(!userData[type][playId]) userData[type][playId] = {"当前对话id":"", "已获得的线索":[]};
            userData[type][playId]["当前对话id"] = dhId;
            userData[type][playId]["已获得的线索"] = [];
            
            if (glxsid) {
                let fruitsEmpty;
                if(glxsid.includes('，')) fruitsEmpty = glxsid.split("，");
                else fruitsEmpty = [glxsid];

                if(!userData[type][playId]["已获得的线索"]) userData[type][playId]["已获得的线索"] = fruitsEmpty
                else {
                    for(let i = 0; i < fruitsEmpty.length; i++) {
                        let 线索data = userData[type][playId]["已获得的线索"].push(fruitsEmpty[i]);
                        let uniqueArray = [...new Set(线索data)];
                        userData[type][playId]["已获得的线索"] = uniqueArray;
                    }
                }
            }
        } else {
            if (userData[type][playId]) {
                if (userData[type][playId]["当前对话id"] == dhId) return;
                else userData[type][playId]["当前对话id"] = dhId;
            } else userData[type][playId] = {"当前对话id":dhId};
            // userData[type][playId]["当前对话id"] = dhId;
            if (glxsid) {
                let fruitsEmpty;
                if(glxsid.includes('，')) fruitsEmpty = glxsid.split("，");
                else fruitsEmpty = [glxsid];

                if(!userData[type][playId]["已获得的线索"]) userData[type][playId]["已获得的线索"] = fruitsEmpty
                else {
                    for(let i = 0; i < fruitsEmpty.length; i++) {
                         userData[type][playId]["已获得的线索"].push(fruitsEmpty[i]);
                    }
                }
            }
        }
    }
}










